



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Open vSwitch 给虚拟机网卡限流（QoS）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Open vSwitch 给虚拟机网卡限流（QoS）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 11:33:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>这里我们简单描述下如何通过Open vSwitch给虚拟机限流（<strong>出流量</strong>），同时测试限流效果。测试环境继续复用<a href="http://www.cnblogs.com/CasonChan/p/4604871.html" rel="external nofollow noreferrer">《整合Open vSwitch与DNSmasq为虚拟机提供DHCP功能》</a>一文中描述的。</p>
<p>测试工具：假设两台虚拟机VM1、VM2都已经安装好 netperf</p>
<p>1、事先在VM1中启动 netserver：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/589795/201506/301423423533275.png" /></p>
<p>2、由于VM2的虚拟网卡是tap1，这里先查看下当前tap1网卡的情况：</p>
<div>
<pre class="prettyprint linenums">◄►  sudo ovs-vsctl list interface tap1<br />
_uuid               : aa4b7e2b-44b9--ab02-909d66fc4333<br />
admin_state         : up<br />
bfd                 : {}<br />
bfd_status          : {}<br />
cfm_fault           : []<br />
cfm_fault_status    : []<br />
cfm_health          : []<br />
cfm_mpid            : []<br />
cfm_remote_mpids    : []<br />
cfm_remote_opstate  : []<br />
duplex              : full<br />
external_ids        : {attached-mac="52:54:00:f9:b6:b1", iface-id="0c9430f2-87ca-4ca2-92c8-2968ddfb2947", iface-status=active, vm-id="8d910a8b-726b-833d-3420-7da607486336"}<br />
ifindex             : <strong><br />
ingress_policing_burst: 0<br />
ingress_policing_rate: 0</strong><br />
lacp_current        : []<br />
link_resets         :<br />
link_speed          :<br />
link_state          : up<br />
mac                 : []<br />
mac_in_use          : "fe:54:00:f9:b6:b1"<br />
mtu                 :<br />
name                : "tap1"<br />
ofport              :<br />
ofport_request      : []<br />
options             : {}<br />
other_config        : {}<br />
statistics          : {collisions=, rx_bytes=, rx_crc_err=, rx_dropped=, rx_errors=, rx_frame_err=, rx_over_err=, rx_packets=, tx_bytes=, tx_dropped=, tx_errors=, tx_packets=}<br />
status              : {driver_name=tun, driver_version="1.6", firmware_version=""}<br />
type                : ""</pre>
</div>
<p>这里的 ingress_policing_rate 和 ingress_policing_burst 值全为0，则表示 不限流。</p>
<p>3、在 不限流 的情况下，从VM2中通过 netperf 测试的情况如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/589795/201506/301430274466516.png" /></p>
<p>从上面的Throughput来看，<strong>出流量</strong>差不多打到了&nbsp; 11Gbps。</p>
<p>4、此时，我们通过 ovs 将 tap1 的带宽限制在 1M：</p>
<div>
<pre class="prettyprint linenums">◄►  sudo ovs-vsctl set interface tap1 ingress_policing_burst=<br />
◄►  sudo ovs-vsctl set interface tap1 ingress_policing_rate=<br />
◄►  sudo ovs-vsctl list Interface tap1<br />
_uuid               : aa4b7e2b-44b9--ab02-909d66fc4333<br />
admin_state         : up<br />
bfd                 : {}<br />
bfd_status          : {}<br />
cfm_fault           : []<br />
cfm_fault_status    : []<br />
cfm_health          : []<br />
cfm_mpid            : []<br />
cfm_remote_mpids    : []<br />
cfm_remote_opstate  : []<br />
duplex              : full<br />
external_ids        : {attached-mac="52:54:00:f9:b6:b1", iface-id="0c9430f2-87ca-4ca2-92c8-2968ddfb2947", iface-status=active, vm-id="8d910a8b-726b-833d-3420-7da607486336"}<br />
ifindex             :<br />
<strong>ingress_policing_burst: </strong><strong><br />
ingress_policing_rate:</strong> <strong></strong><br />
lacp_current        : []<br />
link_resets         :<br />
link_speed          :<br />
link_state          : up<br />
mac                 : []<br />
mac_in_use          : "fe:54:00:f9:b6:b1"<br />
mtu                 :<br />
name                : "tap1"<br />
ofport              :<br />
ofport_request      : []<br />
options             : {}<br />
other_config        : {}<br />
statistics          : {collisions=, rx_bytes=, rx_crc_err=, rx_dropped=, rx_errors=, rx_frame_err=, rx_over_err=, rx_packets=, tx_bytes=, tx_dropped=, tx_errors=, tx_packets=}<br />
status              : {driver_name=tun, driver_version="1.6", firmware_version=""}<br />
type                : ""</pre>
</div>
<p>注意，ingress_policing_rate 和 ingress_policing_burst 的默认单位是 Kbps，这里我们将tap1的带宽限制在了1M。</p>
<p>5、在 带宽为1M 的情况下，从VM2中通过 netperf 测试的情况如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/589795/201506/301439582746492.png" /></p>
<p>这次从上面的Throughput来看，<strong>出流量</strong>也就最大打到了&nbsp; 1Mbps。</p>
<p>6、我们再次将带宽调增到10M，测试情况：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/589795/201506/301441535242149.png" /></p>
<p>这次从上面的Throughput来看，<strong>出流量</strong>最大打到了&nbsp; 10Mbps。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7o7j18.html">高灵活度，高适用性，高性能，轻量级的 ORM 实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7dvxxq.html">APP测试之登录</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvpl7zq.html">经验分享：多屏复杂动画CSS技巧三则</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xxv4e8.html">【MYSQL】创建虚表来辅助数据库查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjdk349.html">C&plus;&plus;中的数组与指针</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd1lzgq.html">nginx&plus;tomcat集群配置&lpar;2&rpar;---静态和动态资源的分离</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xj2jm8.html">WP开发笔记&mdash;&mdash;WP7 SDK使用技巧</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1v76j9.html">jQuery &dollar;&period;post &dollar;&period;ajax用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvpoooq.html">UITableView编写可以添加，删除，移动的物品栏（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmw1g49.html">pdf转图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydm2vmq.html">Can you find it&quest;（hdu 2141 二分查找）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjdn7k8.html">codeforce  Gym 101102A Coins （01背包变形）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meknj2q.html">表连接查询（2-n）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj13vl8.html">swoole多端口监听</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5m3peq.html">error loading midas&period;dll问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9533mrm8.html">命令行下mysql新建用户及分配权限</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmmgng9.html">h5 定位</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn116rq.html">XE 创建 Active Form</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve70lx9.html">mac 必备工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlxwor9.html">二分搜索之C&plus;&plus;实现</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2wwppwq.html">为什么要使用 F&num;？</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k11y3j9.html">sql删除语句</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okkxm59.html">https&colon;&sol;&sol;docs&period;mongodb&period;org&sol;manual&sol;reference&sol;operator&sol;aggregation&sol;unwind&sol;&num;examples</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1p0339.html">HDU 5313 bitset优化背包</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv1v11q.html">11个Linux基础面试问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0zzj4q.html">Android ViewPager 里有子ViewPager的事件冲突</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnee6pq.html">matlab调用opencv函数的配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zkk149.html">ASIHTTPRequest 在release&lpar;打包&rpar;模式下数据获取或post失败问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv116xq.html">提示框alertmsg</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjdpm49.html">MySQL数据类型（四）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
